'''
Created on Mar 26, 2010

@author: seif
'''

from widgets.ui_utils import Thumbnailer, icon_factory

class Item():
    def __init__(self, uri, title, icon=None, comment="", launcher = None, timestamp=0, mimetype=None, subject=None, icon_size=24):
        self.uri = uri
        self.title = title
        self.icon = icon
        self.comment = comment
        self.launcher = launcher
        self.timestamp = timestamp
        self.mimetype = mimetype
        self.subject = subject
        self.icon_size = icon_size
        self.thumbnailer = None
    
    def get_title(self):
        return self.title
    
    def get_icon(self):
        if self.icon:
            return icon_factory.load_icon(self.icon, self.icon_size)

        if not self.thumbnailer:
            self.thumbnailer = Thumbnailer(self.uri, self.mimetype)
        return self.thumbnailer.get_icon(self.icon_size, self.timestamp)
    
class ItemSource(Item):
    def __init__(self, uri, title, icon=None, comment=""):
        Item.__init__(self, uri, title, icon, comment)
        self.items = {
                        2:{
                            1:None,
                            7:None,
                            14:None,
                            30:None,
                            60:None,
                            90:None,
                            180:None,
                        },
                        4:{
                            1:None,
                            7:None,
                            14:None,
                            30:None,
                            60:None,
                            90:None,
                            180:None,
                        },
                    }
        self.needs_refresh = True
        self.zoom_level = 7
        self.sorting = 2
        
    def set_zoom_level(self, zoom_level):
        if not zoom_level == self.zoom_level:
            self.zoom_level = zoom_level
            

    def set_sorting(self, sorting):
        if not sorting == self.sorting:
            self.sorting = sorting
        
    def set_items(self):
        pass
    
    def get_items(self, callback):
        
        def callback2(items):
            self.items[self.sorting][self.zoom_level] = items
            callback(self.items[self.sorting][self.zoom_level])
        
        if self.items[self.sorting][self.zoom_level] == None:
            self.get_items_uncached(callback2)
        else:
            callback(self.items[self.sorting][self.zoom_level])
        self.needs_refresh = False
    
    def get_items_uncached(self):
        pass